SystemOrganization addCategory: #'HTML-Exporter-Tests'!
SystemOrganization addCategory: #'HTML-Exporter'!

Object subclass: #HTMLExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter'!

!HTMLExporter commentStamp: 'SauravBhattacharya 7/17/2012 09:40' prior: 0!
A HTMLExporter is a Smalltalk module for exporting a GenericSpreadsheet class into an HTML format.

Instance Variables
!

!HTMLExporter class methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/18/2012 05:25'!
exportExample
|ghtml as ws  |

as:= GenericSpreadsheet new.
as addNewWorksheetWithTitle: 'Worksheet-2'.
ws := as worksheetWithIndex: 2.
ws maxNumOfColumns:3. "If more than 10, only then need to add cells to Dictionary"
ws maxNumOfRows:3. "If more than 20, only then need to add cells to Dictionary"

(ws cellWithRowIndex: 1 columnIndex: 1) cellValue: 'first'.
(ws cellWithRowIndex: 1 columnIndex: 1) cellType: 'string'.

(ws cellWithRowIndex: 1 columnIndex: 2) cellValue: 1.
(ws cellWithRowIndex: 1 columnIndex: 2) cellType: 'numeric'.

(ws cellWithRowIndex: 1 columnIndex: 3) cellValue: 'second'.
(ws cellWithRowIndex: 1 columnIndex: 3) cellType: 'string'.

(ws cellWithRowIndex: 2 columnIndex: 1) cellValue: 2.
(ws cellWithRowIndex: 2 columnIndex: 1) cellType: 'numeric'.

(ws cellWithRowIndex: 2 columnIndex: 2) cellValue: '2012-06-16'.
(ws cellWithRowIndex: 2 columnIndex: 2) cellType: 'date'.

(ws cellWithRowIndex: 2 columnIndex: 3) cellValue: 4.
(ws cellWithRowIndex: 2 columnIndex: 3) cellType: 'numeric'.

(ws cellWithRowIndex: 3 columnIndex: 1) cellValue: 'fourth'.
(ws cellWithRowIndex: 3 columnIndex: 1) cellType: 'string'.

(ws cellWithRowIndex: 3 columnIndex: 2) cellValue: 3.
(ws cellWithRowIndex: 3 columnIndex: 2) cellType: 'numeric'.

(ws cellWithRowIndex: 3 columnIndex: 3) cellValue: 'third'.
(ws cellWithRowIndex: 3 columnIndex: 3) cellType: 'string'.


ghtml := HTMLExporter new.
ghtml generateHTMLAt:'C:\' filename:'a.html' spreadsheet: as.
! !

!HTMLExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/18/2012 05:31'!
generateHTMLAt: aPath filename: aName spreadsheet: aSpreadsheet
	"comment stating purpose of message"

	| filePath stream numOfWorksheets maxRows maxColumns cell |
	filePath := aPath,aName .
	FileDirectory deleteFilePath: filePath .
	stream := StandardFileStream fileNamed: filePath.
	stream nextPutAll: '<html>
	<title>
		HTML Export of Spreadsheet
	</title>
	<body>
		'.
	stream nextPutAll: '<b>'.
	stream nextPutAll: aSpreadsheet spreadsheetTitle.
	stream nextPutAll: '</b></br>'.
	stream nextPutAll:' '.
	numOfWorksheets := aSpreadsheet numberOfWorksheets .
	1 to: numOfWorksheets do: [:currwb | 
		stream nextPutAll: '<b>'.
		stream nextPutAll: (aSpreadsheet worksheetWithIndex: currwb) worksheetTitle.
		stream nextPutAll: '</b>'.
		stream nextPutAll: '<table border="1">'.
		
		maxRows := (aSpreadsheet worksheetWithIndex: currwb ) maxNumOfRows.
		maxColumns := (aSpreadsheet worksheetWithIndex: currwb ) maxNumOfColumns.
		
		1 to:maxRows do: [:row |
			stream nextPutAll: '<tr>'.
			1 to:maxColumns do: [:col | 
				stream nextPutAll: '<td>'.
				cell:= ((aSpreadsheet worksheetWithIndex: currwb) cellWithRowIndex:row columnIndex:col).
				stream nextPutAll: (cell cellValue)asString  .
				stream nextPutAll: '</td>'.
			].
			stream nextPutAll: '</tr>'.
		].
		stream nextPutAll: '</table>'.
	].
	stream nextPutAll: '
	</body>	
</html>'.
	
	stream cr.
	stream close.
	! !

Object subclass: #HTMLTableGenerator
	instanceVariableNames: 'width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter'!

!HTMLTableGenerator commentStamp: 'SauravBhattacharya 7/17/2012 09:40' prior: 0!
Class intention
	Given width and height as parameters, generate an empty HTML table.

Class collaborations
	I usually do not work in isolation but with the help of Yuriy Mironenko, Carla Florencia

!

!HTMLTableGenerator methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 5/20/2012 01:13'!
generateHTMLTableAt: aPath filename: aName
	"Generates an HTML table with instance width and height at the entered location with the entered filname"

	| stream filePath fileName countCol countRow |
	filePath := aPath,aName .
	stream := StandardFileStream fileNamed: filePath .
	stream  nextPutAll: '<html>
	<body>
	Hello Smalltalk!!
	<table border="1">'.
	countCol:=0.
	[countCol >= height] whileFalse: 
	
	[stream nextPutAll: '<tr>'. 
	countRow :=0.
	[countRow=width] whileFalse: 
	[stream nextPutAll: '<td>'. stream nextPutAll: 'cell'.  stream nextPutAll: '</td>'. countRow:=countRow+1.] .
	stream nextPutAll: '</tr>'.
	countCol := countCol+ 1.
	].
	stream nextPutAll: '</table>'.
	stream  cr.
	stream close.
	
	! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 22:47'!
height 
	"comment stating purpose of message"

	| temporary variable names |
	^ height.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 23:00'!
height: aHeight
	"comment stating purpose of message"

	| temporary variable names |
	height:= aHeight .! !

!HTMLTableGenerator methodsFor: 'initialize-release' stamp: 'SauravBhattacharya 5/17/2012 22:59'!
initialize 
	"comment stating purpose of message"

	| temporary variable names |
	super initialize.
	width:= 2.
	height:= 2.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 22:47'!
width 
	"comment stating purpose of message"

	| temporary variable names |
	^ width.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/18/2012 17:39'!
width: aWidth
	"comment stating purpose of message"

	| temporary variable names |
	width:=aWidth .! !

TestCase subclass: #HTMLTableGeneratorTest
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter-Tests'!

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 14:45'!
setUp 
	"comment stating purpose of message"

	| temporary variable names |
	t := HTMLTableGenerator new.
	
	! !

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 14:48'!
testHeight
	"comment stating purpose of message"

	| temporary variable names temp |
	temp := 18.
	t height: temp.
	self assert: (t height  = temp ).! !

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 15:20'!
testWidth
	"comment stating purpose of message"

	| temp |
	temp := 18.
	t width: temp.
	self assert: (t width = temp ).! !
